<!--
Author:         Jakub Schon
Company:        Husky Energy
History:        jschn 28/08/2019 - Created.
 -->
<!-- VTT WOA List View Result Card -->
<!--suppress HtmlUnknownTag -->
<template>

	<lightning-card  title="Results">
		<div slot="actions">
			<div class="slds-hide_large">
				<lightning-button-group >
					<lightning-button-icon icon-name="utility:play"
										   if:true={isAvailableStartWork}
										   alternative-text="Start Work"
										   disabled={cannotStartWork}
										   onclick={handleStartWork}></lightning-button-icon>
					<lightning-button-icon icon-name="utility:macros"
										   if:true={isAvailableJobInProgress}
										   alternative-text="Job In Progress"
										   onclick={handleJobInProgress}></lightning-button-icon>
					<lightning-button-icon icon-name="utility:adduser"
										   if:true={isAvailableManageAssignments}
										   alternative-text="Manage Assignments"
										   onclick={handleManageAssignments}></lightning-button-icon>
					<lightning-button-icon icon-name="utility:magicwand"
										   if:true={isAvailableRunAutoAssignments}
										   alternative-text="Run Auto Assignments"
										   onclick={runAutoAssignments}></lightning-button-icon>
					<lightning-button-icon icon-name="utility:refresh"
										   alternative-text="Reload"
										   if:true={reloadAvailable}
										   onclick={reload}></lightning-button-icon>
					<lightning-button-icon icon-name="utility:toggle_panel_left"
										   alternative-text="Toggle search bar"
										   onclick={toggleSearch}></lightning-button-icon>
				</lightning-button-group>
			</div>
			<div class="slds-show_large">
				<lightning-button-group >
					<lightning-button label="Start Work"
									  if:true={isAvailableStartWork}
									  icon-name="utility:play"
									  disabled={cannotStartWork}
									  onclick={handleStartWork}></lightning-button>
					<lightning-button label="Job In Progress"
									  icon-name="utility:macros"
									  if:true={isAvailableJobInProgress}
									  onclick={handleJobInProgress}></lightning-button>
					<lightning-button label="Manage Assignments"
									  icon-name="utility:adduser"
									  if:true={isAvailableManageAssignments}
									  onclick={handleManageAssignments}></lightning-button>
					<lightning-button label="Run Auto Assignments"
									  icon-name="utility:magicwand"
									  if:true={isAvailableRunAutoAssignments}
									  onclick={runAutoAssignments}></lightning-button>
					<lightning-button-icon icon-name="utility:refresh"
										   alternative-text="Reload"
										   if:true={reloadAvailable}
										   onclick={reload}></lightning-button-icon>
					<lightning-button-icon icon-name="utility:toggle_panel_left"
										   alternative-text="Toggle search bar"
										   onclick={toggleSearch}></lightning-button-icon>
				</lightning-button-group>
			</div>
		</div>

		<template if:true={showManageAssignments}>
			<c-vtt_woa_manage-assignments woa-ids={selectedIds}
										  mode="STANDALONE"
										  onsuccessassignment={handleManageAssignmentsSuccess}
										  onclose={handleManageAssignmentsClose}>
			</c-vtt_woa_manage-assignments>
		</template>
		<template if:true={showStartWorkPopup}>
			<c-vtt_woa_start-work_popup tradesman={tradesmanInfo.tradesman}
										onclose={handleStartWorkNo}
										onsuccess={handleStartWorkYes}>
			</c-vtt_woa_start-work_popup>
		</template>

		<lightning-spinner if:true={loading}
						   size="medium"
						   alternative-text="Loading..."
						   variant="brand"></lightning-spinner>
		<div class="slds-spinner_container"
			 if:true={processing}>
			<div role="status" class="slds-spinner slds-spinner_medium slds-spinner_brand top-spinner">
				<span class="slds-assistive-text">Processing...</span>
				<div class="slds-spinner__dot-a"></div>
				<div class="slds-spinner__dot-b"></div>
			</div>
		</div>

		<div class="slds-p-horizontal_small">
			<div if:true={showTable}>
				Records: {recordCount}<template if:false={allRecordsLoaded}>+</template>

				<lightning-layout multiple-rows="true">
					<lightning-layout-item class="slds-p-top--xx-small"
										   size="12"
										   large-device-size="6"
										   medium-device-size="6"
										   small-device-size="12">
						<lightning-button-group >
							<lightning-button label="Expand all"
											  icon-name="utility:expand_all"
											  onclick={handleExpand}></lightning-button>
							<lightning-button label="Collapse all"
											  icon-name="utility:collapse_all"
											  onclick={handleCollapse}></lightning-button>
						</lightning-button-group>
					</lightning-layout-item>
					<lightning-layout-item size="12"
										   large-device-size="6"
										   medium-device-size="6"
										   small-device-size="12">
						<lightning-combobox label="Order By: "
											variant="label-inline"
											options={orderOptions}
											value={order}
											onchange={handleOrderChange}></lightning-combobox>
					</lightning-layout-item>
				</lightning-layout>

				<ul>
					<c-vtt_woa-list-view_result-item for:each={records}
													 key={record.Id}
													 for:item=record
													 tradesman-info={tradesmanInfo}
													 record={record}></c-vtt_woa-list-view_result-item>
				</ul>

				<div class="slds-align--absolute-center" id="loadMoreSection">
					<lightning-spinner if:true={additionalLoading}
									   size="small"
									   class="slds-is-relative"
									   alternative-text="Loading..."
									   variant="brand"></lightning-spinner>
					<lightning-button label="Load more"
									  if:true={possibleAdditionalLoading}
									  onclick={loadMore}></lightning-button>
				</div>
			</div>
			<c-hog_error-msg error-message={errorMessage}></c-hog_error-msg>
			<p if:false={showTable}>
				No records.
			</p>
		</div>
	</lightning-card>

</template>